package com.buuz135.materialized;

import com.buuz135.materialized.api.MaterialRegistry;
import com.buuz135.materialized.api.material.info.MaterialInfo;
import com.buuz135.materialized.proxy.CommonProxy;
import com.buuz135.materialized.utils.Reference;
import com.google.gson.Gson;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;


@Mod(modid = Reference.MODID, name = Reference.MODID, version = Reference.VERSION)
public class Materialized {

    public static Logger LOGGER = LogManager.getLogger(Reference.MODID);

    public static CreativeTabs creativeTab = new CreativeTabs(Reference.MODID) {
        @Override
        public ItemStack func_78016_d() {
            return new ItemStack(Blocks.field_150348_b);
        }
    };

    @SidedProxy(clientSide = Reference.PROXY_CLIENT, serverSide = Reference.PROXY_COMMON)
    private static CommonProxy proxy;

    @Mod.EventHandler
    public void preInit(FMLPreInitializationEvent event) throws IOException {
        File direc = new File(event.getModConfigurationDirectory().getAbsolutePath() + File.separator + Reference.MODID);
        if (!direc.exists()) direc.mkdir();
        File json = new File(direc.getAbsolutePath() + File.separator + "materials.json");
        if (json.exists()) {
            FileReader reader = new FileReader(json);
            MaterialInfo[] materialInfos = new Gson().fromJson(reader, MaterialInfo[].class);
            reader.close();
            for (MaterialInfo materialInfo : materialInfos) {
                MaterialRegistry.INSTANCE.addMaterial(materialInfo);
            }
        }
        //proxy.preInit(event);
    }

    @Mod.EventHandler
    public void init(FMLInitializationEvent event) {
        proxy.init(event);
    }

    @Mod.EventHandler
    public void postInit(FMLPostInitializationEvent event) {
        proxy.postInit(event);
    }
}
