package com.buuz135.materialized.api.item;

import com.buuz135.materialized.Materialized;
import com.buuz135.materialized.api.material.ItemMaterial;
import com.buuz135.materialized.proxy.client.RenderHelper;
import com.buuz135.materialized.utils.Reference;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.translation.I18n;
import net.minecraftforge.fml.common.registry.GameRegistry;
import org.apache.commons.lang3.text.WordUtils;

public class MaterializedItem extends Item {

    private ItemMaterial itemMaterial;
    private String name;

    public MaterializedItem(ItemMaterial itemMaterial, String name) {
        this.itemMaterial = itemMaterial;
        this.name = name;
        this.setRegistryName(Reference.MODID, itemMaterial.getName() + name);
        this.func_77637_a(Materialized.creativeTab);
    }

    @Override
    public String func_77653_i(ItemStack stack) {
        return (I18n.func_94522_b("material." + name + ".name") ? I18n.func_74838_a("material." + name + ".name") : WordUtils.capitalize(name)) + " " + I18n.func_74838_a("type." + itemMaterial.getName() + ".name");
    }

    public void register() {
        GameRegistry.register(this);
    }

    public void registerRender() {
        RenderHelper.registerVariantItem(this, itemMaterial, "inventory");
    }
}
