package com.buuz135.materialized.proxy.client;

import com.buuz135.materialized.api.MaterialRegistry;
import com.buuz135.materialized.api.block.ColoredMaterializedBlock;
import com.buuz135.materialized.api.item.ColoredMaterializedItem;
import com.buuz135.materialized.proxy.CommonProxy;
import net.minecraft.client.Minecraft;
import net.minecraft.item.Item;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

public class ClientProxy extends CommonProxy {
    @Override
    public void preInit(FMLPreInitializationEvent event) {
        super.preInit(event);
    }

    @Override
    public void init(FMLInitializationEvent event) {
        super.init(event);
        MaterialRegistry.INSTANCE.getMaterials().forEach((s, createdMaterial) -> {
                    createdMaterial.getMaterializedBlockHashMap().forEach((blockPart, block) -> registerColor(block, blockPart.getLayer()));
                    createdMaterial.getMaterializedItemHashMap().forEach((material, coloredMaterializedItem) -> registerColor(coloredMaterializedItem, material.getLayer()));
                }
        );
    }

    @Override
    public void postInit(FMLPostInitializationEvent event) {
        super.postInit(event);
    }

    private void registerColor(ColoredMaterializedBlock ore, int index) {
        if (ore != null) {
            Minecraft.func_71410_x().getItemColors().func_186731_a((stack, tintIndex) -> {
                if (tintIndex == index && stack.func_77973_b().equals(Item.func_150898_a(ore))) {
                    return ore.getColor();
                }
                return 0xFFFFFF;
            }, ore);
            Minecraft.func_71410_x().func_184125_al().func_186722_a((state, worldIn, pos, tintIndex) -> {
                if (tintIndex == index && state.func_177230_c().equals(ore)) {
                    return ore.getColor();
                }
                return 0xFFFFFF;
            }, ore);
        }
    }

    private void registerColor(ColoredMaterializedItem item, int index) {
        if (item != null) {
            Minecraft.func_71410_x().getItemColors().func_186730_a((stack, tintIndex) -> {
                if (tintIndex == index && stack.func_77973_b().equals(item)) {
                    return item.getColor();
                }
                return 0xFFFFFF;
            }, item);
        }
    }

}
